;
;   Sample Action Replay ROM replacement
;   Note:   This implementation allows original AR ROM to be restored.
;
;   Copyright (C) Foo Chen Hon 1997. All rights reserved.
;


	opt	c+


	org	$1F000000


	dw	entryPoint2		; location of 2nd entry point
	; this verification string must be present here!
	db	"Licensed by Sony Computer Entertainment Inc."
	; you can add in your own copyright here!

	org	$1F000080


	dw	entryPoint1		; location of 1st entry point
	; this verification string must be present here!
	db	"Licensed by Sony Computer Entertainment Inc."
	; you can add in your own copyright here!

	org	$1F000100


entryPoint1:
	lui	v0,$1F06		;check if command=='W' from PC
	lbu	v0,$0000(v0)
	addiu	v1,zero,'W'
	beq	v0,v1,processCommLink
	nop

	; do whatever you want here!
	jr	ra
	nop


entryPoint2:
	; do whatever you want here!
	jr	ra
	nop


;
;   void processCommLink()
;   {
;	while ((arReadWrite('R') != 'W');
;	while ((arReadWrite('W') != 'B');
;	if (arRead() != 'X')
;	{
;	    arReadWrite('B');
;	    arReadWrite('X');
;	}
;	else
;	{
;	    checksum  = 0;
;	    destaddr  = arRead();
;	    destaddr += (destaddr << 8) + arRead();
;	    destaddr += (destaddr << 8) + arRead();
;	    destaddr += (destaddr << 8) + arRead();
;	    length    = arRead();
;	    length   += (length << 8) + arRead();
;	    length   += (length << 8) + arRead();
;	    length   += (length << 8) + arRead();
;	    pdest     = destaddr;
;	    while (length-- > 0)
;	    {
;		data	 = arRead();
;		checksum = (checksum + data) & 0x0FFF;
;		*pdest++ = data;
;	    }
;	    rchecksum  = arRead();
;	    rchecksum += (rchecksum << 8) + arRead();
;	    if (checksum == rchecksum)
;	    {
;		arReadWrite('O');
;		arReadWrite('K');
;		(*destaddr)();
;	    }
;	    else
;	    {
;		arReadWrite('B');
;		arReadWrite('C');
;	    }
;	}
;   }
;
processCommLink:
	addiu	sp,sp,$FFFFFFDC
	sw	ra,$0020(r29)
	sw	s3,$001C(r29)
	sw	s2,$0018(r29)
	sw	s1,$0014(r29)
	sw	s0,$0010(r29)
	addiu	s0,zero,'W'
@wait0:
	jal	arReadWrite
	addiu	a0,zero,'R'
	bne	v0,s0,@wait0
	nop
	addiu	s0,zero,'B'
@wait1:
	jal	arReadWrite
	addiu	a0,zero,'W'
	bne	v0,s0,@wait1
	nop
	jal	arRead
	nop
	addiu	v1,zero,'X'
	beq	v1,v0,@next
	nop
	jal	arReadWrite
	addiu	a0,zero,'B'
	jal	arReadWrite
	addiu	a0,zero,'X'
	beq	zero,zero,@exit
	nop
@next:
	jal	arRead
	addu	s1,zero,zero
	jal	arRead
	addu	s2,v0,zero
	sll	s2,s2,8
	jal	arRead
	addu	s2,s2,v0
	sll	s2,s2,8
	jal	arRead
	addu	s2,s2,v0
	sll	s2,s2,8
	jal	arRead
	addu	s2,s2,v0
	jal	arRead
	addu	s3,v0,zero
	sll	s3,s3,8
	jal	arRead
	addu	s3,s3,v0
	sll	s3,s3,8
	jal	arRead
	addu	s3,s3,v0
	sll	s3,s3,8
	addu	s3,s3,v0
	beq	s3,zero,@checksum
	addu	s0,s2,zero
@getbyte:
	jal	arRead
	addiu	s3,s3,-1
	addu	s1,s1,v0
	andi	s1,s1,$0FFF
	sb	v0,$0000(s0)
	bne	s3,zero,@getbyte
	addiu	s0,s0,1
@checksum:
	jal	arRead
	nop
	jal	arRead
	addu	s0,v0,zero
	sll	s0,s0,8
	addu	s0,s0,v0
	bne	s0,s1,@error
	nop
	jal	arReadWrite
	addiu	a0,zero,'O'
	jal	arReadWrite
	addiu	a0,zero,'K'
	jalr	ra,s2
	nop
	beq	zero,zero,@exit
	nop
@error:
	jal	arReadWrite
	addiu	a0,zero,'B'
	jal	arReadWrite
	addiu	a0,zero,'C'
@exit:
	lw	ra,$0020(r29)
	lw	s3,$001C(r29)
	lw	s2,$0018(r29)
	lw	s1,$0014(r29)
	lw	s0,$0010(r29)
	jr	ra
	addiu	sp,sp,$0024


;
;   char arReadWrite(char data)
;   {
;	while ((*statusport & 1) == 0);
;	retval = *readport;
;	*writeport = data;
;	return retval;
;   }
;
arReadWrite:
	lui	v1,$1F02
	lui	a1,$1F06
@check:
	lbu	v0,$0010(v1)		; read ar statusport
	nop
	andi	v0,v0,$0001
	beq	v0,zero,@check		; loop till bit 0 is 1
	nop
	lbu	v0,$0000(a1)		; read data
	sb	a0,$0008(a1)		; write data
	jr	ra
	nop


;
;   char arRead()
;   {
;	while ((*statusport & 1) == 0);
;	retval = *readport;
;	*writeport = retval;
;	return retval;
;   }
;
arRead:
	lui	v1,$1F02
	lui	a0,$1F06
@check:
	lbu	v0,$0010(v1)		; read ar statusport
	nop
	andi	v0,v0,$0001
	beq	v0,zero,@check		; loop till bit 0 is 1
	nop
	lbu	v0,$0000(a0)		; read data
	nop
	sb	v0,$0008(a0)		; write data
	jr	ra
	nop


	cnop	0,1024


	end
